function CRunrpg_athumaru_api(){
	this.tmp_rec = null ; this.tmp_rec_st = 0;
	this.tmp_global = null; this.tmp_global_st = 0;
	this.tmp_shared = null; this.tmp_shared_st = 0; this.tmp_shared_tid = 0;
	this.tmp_self = null; this.tmp_self_st = 0;
	this.tmp_user = null; this.tmp_user_st = 0;
	this.tmp_recent = null; this.tmp_recent_st = 0;
	this.tmp_active_u = null; this.tmp_active_u_st = 0;
	this.tmp_signal = null; this.tmp_signal_st = 0;
	this.tmp_user_sig = null; this.tmp_user_sig_st = 0;
	
	this.tmp_getpoints = null; this.tmp_getpoints_st = 0;
	this.tmp_histories = null; this.tmp_histories_st = 0;
	this.tmp_ranking = null; this.tmp_tmp_ranking_st = 0;
}
CRunrpg_athumaru_api.prototype = CServices.extend(new CRunExtension(),{
	getNumberOfConditions: function (){
		return 0;
	},
	createRunObject: function (file, cob, version){
		return true;
	},
	action: function (num, act){
		if( typeof RPGAtsumaru === "undefined" )
			return;
		switch (num){
			case 0:	// DisplayScoreBoard
				RPGAtsumaru["experimental"]["scoreboards"]["display"]( act.getParamExpression(this.rh, 0) );
				break;
			case 1:	// SetRecord
				RPGAtsumaru["experimental"]["scoreboards"]["setRecord"]( act.getParamExpression(this.rh, 0) , act.getParamExpression(this.rh, 1) ) ;
				break;
			case 2:	// OpenLink
				RPGAtsumaru["popups"]["openLink"]( act.getParamExpString(this.rh, 0) );
				break;
			case 3:	// ChangeScene
				RPGAtsumaru["comment"]["changeScene"](act.getParamExpString(this.rh, 0));
				break;
			case 4:	// resetAndChangeScene
				RPGAtsumaru["comment"]["resetAndChangeScene"](act.getParamExpString(this.rh, 0));
				break;
			case 5:	// pushContextFactor
				RPGAtsumaru["comment"]["pushContextFactor"](act.getParamExpString(this.rh, 0));
				break;
			case 6:	// pushMinorContext
				RPGAtsumaru["comment"]["pushMinorContext"]();
				break;
			case 7:	// setContext
				RPGAtsumaru["comment"]["setContext"](act.getParamExpString(this.rh, 0));
				break;
				
			case 8:	// displayCreatorInformationModal
				if( act.getParamExpression(this.rh, 0) == 0 )
					RPGAtsumaru["experimental"]["popups"]["displayCreatorInformationModal"]();
				else
					RPGAtsumaru["experimental"]["popups"]["displayCreatorInformationModal"](act.getParamExpression(this.rh, 0));
				break;
			case 9:	// displayModal(screenshot)
				RPGAtsumaru["experimental"]["screenshot"]["displayModal"]();
				break;
			case 10:// setTweetMessage(screenshot)
				RPGAtsumaru["experimental"]["screenshot"]["setTweetMessage"](
				{ "tweetText" : act.getParamExpString(this.rh, 0) ,
				  "param1" : act.getParamExpString(this.rh, 1 ), 
				  "param2" : act.getParamExpString(this.rh, 2 ) });
				break;
			case 11:// getRecords
				this.tmp_rec_st = 1;
				var p = RPGAtsumaru["experimental"]["scoreboards"]["getRecords"](act.getParamExpression(this.rh, 0));
				p.then((value)=>{ this.tmp_rec = value; this.tmp_rec_st = 2 ; },(error)=>{ this.tmp_rec = null; this.tmp_rec_st = -1;});
				break;
			case 12:// getGlobalServerVariable
				this.tmp_global_st = 1;
				var p = RPGAtsumaru["experimental"]["globalServerVariable"]["getGlobalServerVariable"](act.getParamExpression(this.rh, 0));
				p.then((value)=>{ this.tmp_global = value; this.tmp_global_st = 2 ; },(error)=>{ this.tmp_global = null; this.tmp_global_st = -1;});
				break;
			case 13:// getGlobalServerVariableByName
				this.tmp_global_st = 1;
				var p = RPGAtsumaru["experimental"]["globalServerVariable"]["getGlobalServerVariableByName"](act.getParamExpString(this.rh, 0));
				p.then((value)=>{ this.tmp_global = value; this.tmp_global_st = 2 ; },(error)=>{ this.tmp_global = null; this.tmp_global_st = -1;});
				break;
			case 14:// triggerCall - id
				RPGAtsumaru["experimental"]["globalServerVariable"]["triggerCall"](act.getParamExpression(this.rh, 0));
				break;
			case 15:// triggerCall - id & val
				RPGAtsumaru["experimental"]["globalServerVariable"]["triggerCall"](act.getParamExpression(this.rh, 0),act.getParamExpression(this.rh, 1));
				break;
			case 16:// triggerCall - id & str
				RPGAtsumaru["experimental"]["globalServerVariable"]["triggerCall"](act.getParamExpression(this.rh, 0),act.getParamExpString(this.rh, 1));
				break;
			case 17:// triggerCallByName - id
				RPGAtsumaru["experimental"]["globalServerVariable"]["triggerCallByName"](act.getParamExpString(this.rh, 0));
				break;
			case 18:// triggerCallByName - id & val
				RPGAtsumaru["experimental"]["globalServerVariable"]["triggerCallByName"](act.getParamExpString(this.rh, 0),act.getParamExpression(this.rh, 1));
				break;
			case 19:// triggerCallByName - id & str
				RPGAtsumaru["experimental"]["globalServerVariable"]["triggerCallByName"](act.getParamExpString(this.rh, 0),act.getParamExpString(this.rh, 1));
				break;
				
			case 20:// getSharedItems (single... multi array)
				var gameid = act.getParamExpression(this.rh, 1);
				var p;
				this.tmp_shared_st = 1;
				this.tmp_shared_tid = act.getParamExpression(this.rh, 0);
				if( gameid == 0 )
					p = RPGAtsumaru["experimental"]["storage"]["getSharedItems"]([this.tmp_shared_tid]);
				else
					p = RPGAtsumaru["experimental"]["storage"]["getSharedItems"]([this.tmp_shared_tid] , gameid );
				p.then((value)=>{ this.tmp_shared = value; this.tmp_shared_st = 2 ; },(error)=>{ this.tmp_shared = null; this.tmp_shared_st = -1;});
				break;
			case 21:// setSharedSave
				RPGAtsumaru["storage"]["setItems"]([{ key: "Atsumaru Shared" , value : act.getParamExpString(this.rh, 0) }]);
				break;
			
			case 22:// getSelfInformation
				this.tmp_self_st = 1;
				var p = RPGAtsumaru["experimental"]["user"]["getSelfInformation"]();
				p.then((value)=>{ this.tmp_self = value; this.tmp_self_st = 2 ; },(error)=>{ this.tmp_self = null; this.tmp_self_st = -1;});
				break;
			case 23:// getUserInformation
				this.tmp_user_st = 1;
				var p = RPGAtsumaru["experimental"]["user"]["getUserInformation"](act.getParamExpression(this.rh, 0));
				p.then((value)=>{ this.tmp_user = value; this.tmp_user_st = 2 ; },(error)=>{ this.tmp_user = null; this.tmp_user_st = -1;});
				break;
			case 24:// getRecentUsers
				this.tmp_recent_st = 1;
				var p = RPGAtsumaru["experimental"]["user"]["getRecentUsers"]();
				p.then((value)=>{ this.tmp_recent = value; this.tmp_recent_st = 2 ; },(error)=>{ this.tmp_recent = null; this.tmp_recent_st = -1;});
				break;
			case 25:// sendSignalToGlobal
				RPGAtsumaru["experimental"]["signal"]["sendSignalToGlobal"](act.getParamExpString(this.rh, 0));
				break;
			case 26:// getGlobalSignals
				this.tmp_signal_st = 1;
				var p = RPGAtsumaru["experimental"]["signal"]["getGlobalSignals"]();
				p.then((value)=>{ this.tmp_signal = value; this.tmp_signal_st = 2 ; },(error)=>{ this.tmp_signal = null; this.tmp_signal_st = -1;});
				break;
			case 27:// sendSignalToUser
				RPGAtsumaru["experimental"]["signal"]["sendSignalToUser"](act.getParamExpression(this.rh, 0),act.getParamExpString(this.rh, 1));
				break;
			case 28:// getUserSignals
				this.tmp_user_sig_st = 1;
				var p = RPGAtsumaru["experimental"]["signal"]["getUserSignals"]();
				p.then((value)=>{ this.tmp_user_sig = value; this.tmp_user_sig_st = 2 ; },(error)=>{ this.tmp_user_sig = null; this.tmp_user_sig_st = -1;});
			case 29:// clearRecordBuffer
				this.tmp_rec = null;
				break;
			case 30:// clearGlobalServerVariableBuffer
				this.tmp_global = null;
				break;
			case 31:// clearSharedItemBuffer
				this.tmp_shared = null;
				break;
			case 32:// clearSelfInformationBuffer
				this.tmp_self = null;
				break;
			case 33:// clearUserInformationBuffer
				this.tmp_user = null;
				break;
			case 34:// clearGlobalSignalBuffer
				this.tmp_signal = null;
				break;
			case 35:// clearUserSignalBuffer
				this.tmp_user_sig = null;
				break;
			case 36:// interplayer_enable
				RPGAtsumaru["experimental"]["interplayer"]["enable"]();
				break;
			case 37:// getActiveUserCount
				this.tmp_active_u_st = 1;
				var p = RPGAtsumaru["experimental"]["user"]["getActiveUserCount"](act.getParamExpression(this.rh, 0));
				p.then((value)=>{ this.tmp_active_u = value; this.tmp_active_u_st = 2 ; },(error)=>{ this.tmp_active_u = null; this.tmp_active_u_st = -1;});
				break;
			case 38:// clearRecentUserBuffer
				this.tmp_recent = null;
				break;
			case 39:// clearActiveUserBuffer
				this.tmp_active_u = null;
			
			case 40:// nicoad_getPoints
				this.tmp_getpoints_st = 1;
				var p = RPGAtsumaru["experimental"]["nicoad"]["getPoints"]();
				p.then((value)=>{ this.tmp_getpoints = value; this.tmp_getpoints_st = 2 ; },(error)=>{ this.tmp_getpoints = null; this.tmp_getpoints_st = -1;});
				break;
			case 41:// nicoad_getHistories
				this.tmp_histories_st = 1;
				var p = RPGAtsumaru["experimental"]["nicoad"]["getHistories"]();
				p.then((value)=>{ this.tmp_histories = value; this.tmp_histories_st = 2 ; },(error)=>{ this.tmp_histories = null; this.tmp_histories_st = -1;});
				break;
			case 42:// nicoad_getRanking
				this.tmp_tmp_ranking_st = 1;
				var p = RPGAtsumaru["experimental"]["nicoad"]["getRanking"]();
				p.then((value)=>{ this.tmp_ranking = value; this.tmp_tmp_ranking_st = 2 ; },(error)=>{ this.tmp_ranking = null; this.tmp_tmp_ranking_st = -1;});
				break;
			case 43:// nicoad_clearGetPointsBuffer
				this.tmp_getpoints = null;
				break;
			case 44:// nicoad_clearGetHistoriesBuffer
				this.tmp_histories = null;
				break;
			case 45:// nicoad_clearGetRankingBuffer
				this.tmp_ranking = null;
				break;
			case 46:// removeSharedItem
				RPGAtsumaru["storage"]["removeItem"]("Atsumaru Shared");
				break;
		}
	},
	expression: function (num){
		switch (num){
			case 0:	//	myRecord - isNewRecord
				if( this.tmp_rec == null )return 0;
				if( this.tmp_rec["myRecord"]["isNewRecord"] == true ) return 1;
				else return 0;
			case 1:	//	myRecord - rank
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["myRecord"]["rank"];
			case 2:	//	myRecord - score
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["myRecord"]["score"];
				
			case 3:	//	myBestRecord - userName
				if( this.tmp_rec == null )return "";
				return this.tmp_rec["myBestRecord"]["userName"];
			case 4:	//	myBestRecord - rank
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["myBestRecord"]["rank"];
			case 5:	//	myBestRecord - score
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["myBestRecord"]["score"];
			case 6:	//	myBestRecord - userId
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["myBestRecord"]["userId"];
				
			case 7:	//	ranking - userName
				if( this.tmp_rec == null )return "";
				return this.tmp_rec["ranking"][this.ho.getExpParam()]["userName"];
			case 8:	//	ranking - rank
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["ranking"][this.ho.getExpParam()]["rank"];
			case 9:	//	ranking - score
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["ranking"][this.ho.getExpParam()]["score"];
			case 10://	ranking - userId
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["ranking"][this.ho.getExpParam()]["userId"];
			
			case 11://	boardId
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["boardId"];
			case 12://	boardName
				if( this.tmp_rec == null )return "";
				return this.tmp_rec["boardName"];
			
			case 13://	globalServerVariable - name
				if( this.tmp_global == null )return "";
				return this.tmp_global["name"];
			case 14://	globalServerVariable - maxValue
				if( this.tmp_global == null )return 0;
				return this.tmp_global["maxValue"];
			case 15://	globalServerVariable - minValue
				if( this.tmp_global == null )return 0;
				return this.tmp_global["minValue"];
			case 16://	globalServerVariable - value
				if( this.tmp_global == null )return 0;
				return this.tmp_global["value"];
			
			case 17://	getSharedItems (single... multi array)
				if( this.tmp_shared == null || this.tmp_shared[ this.tmp_shared_tid ] === undefined )return "";
				return this.tmp_shared[ this.tmp_shared_tid ];
			
			case 18://	getSelfInformation - id
				if( this.tmp_self == null )return 0;
				return this.tmp_self["id"];
			case 19://	getSelfInformation - name
				if( this.tmp_self == null )return "";
				return this.tmp_self["name"];
			case 20://	getSelfInformation - profile
				if( this.tmp_self == null )return "";
				return this.tmp_self["profile"];
			case 21://	getSelfInformation - twitterId
				if( this.tmp_self == null )return "";
				return this.tmp_self["twitterId"];
			case 22://	getSelfInformation - url
				if( this.tmp_self == null )return "";
				return this.tmp_self["url"];
			case 23://	getSelfInformation - isPremium
				if( this.tmp_self == null )return 0;
				if( this.tmp_self["isPremium"] == true )return 1;
				return 0;
			
			case 24://	getUserInformation - id
				if( this.tmp_user == null )return 0;
				return this.tmp_user["id"];
			case 25://	getUserInformation - name
				if( this.tmp_user == null )return "";
				return this.tmp_user["name"];
			case 26://	getUserInformation - profile
				if( this.tmp_user == null )return "";
				return this.tmp_user["profile"];
			case 27://	getUserInformation - twitterId
				if( this.tmp_user == null )return "";
				return this.tmp_user["twitterId"];
			case 28://	getUserInformation - url
				if( this.tmp_user == null )return "";
				return this.tmp_user["url"];
			
			case 29://	getRecentUserCount
				if( this.tmp_recent != null ) return this.tmp_recent.length;
				return 0;
			case 30://	getRecentUsers - id
				if( this.tmp_recent == null ) return 0;
				return this.tmp_recent[this.ho.getExpParam()]["id"];
			case 31://	getRecentUsers - name
				if( this.tmp_recent == null ) return "";
				return this.tmp_recent[this.ho.getExpParam()]["name"];
			
			case 32://	getActiveUserCount
				if( this.tmp_active_u == null ) return -1;
				return this.tmp_active_u;
			
			case 33:// getGlobalSignalCount
				if( this.tmp_signal != null ) return this.tmp_signal.length;
				return 0;
			case 34:// getGlobalSignalData - timestamp
				if( this.tmp_signal != null )
					return this.tmp_signal[this.ho.getExpParam()]["createdAt"];
				break;
			case 35:// getGlobalSignalData - data
				if( this.tmp_signal != null )
					return this.tmp_signal[this.ho.getExpParam()]["data"];
				break;
			case 36:// getGlobalSignalData - id
				if( this.tmp_signal != null )
					return this.tmp_signal[this.ho.getExpParam()]["id"];
				break;
			case 37:// getGlobalSignalData - senderId
				if( this.tmp_signal != null )
					return this.tmp_signal[this.ho.getExpParam()]["senderId"];
				break;
			case 38:// getGlobalSignalData - senderName
				if( this.tmp_signal != null )
					return this.tmp_signal[this.ho.getExpParam()]["senderName"];
				break;
			
			case 39:// getUserSignalCount 
				if( this.tmp_user_sig != null ) return this.tmp_user_sig.length;
					return 0;
			case 40:// getUserSignalData - id
				if( this.tmp_user_sig != null )
					return this.tmp_user_sig[this.ho.getExpParam()]["id"];
				break;
			case 41:// getUserSignalData - senderId
				if( this.tmp_user_sig != null )
					return this.tmp_user_sig[this.ho.getExpParam()]["senderId"];
				break;
			case 42:// getUserSignalData - senderName
				if( this.tmp_user_sig != null )
					return this.tmp_user_sig[this.ho.getExpParam()]["senderName"];
				break;
			case 43:// getUserSignalData - data
				if( this.tmp_user_sig != null )
					return this.tmp_user_sig[this.ho.getExpParam()]["data"];
				break;
			case 44:// getUserSignalData - timestamp
				if( this.tmp_user_sig != null )
					return this.tmp_user_sig[this.ho.getExpParam()]["createdAt"];
				break;
			case 45:// ranking - count
				if( this.tmp_rec == null )return 0;
				return this.tmp_rec["ranking"].length;
			
			case 46:// record_load_status
				return this.tmp_rec_st;
			case 47:// global_load_status
				return this.tmp_global_st;
			case 48:// shared_load_status
				return this.tmp_shared_st;
			case 49:// self_load_status
				return this.tmp_self_st;
			case 50:// user_load_status
				return this.tmp_user_st;
			case 51:// resent_load_status
				return this.tmp_recent_st;
			case 52:// global_signal_load_status
				return this.tmp_signal_st;
			case 53:// user_signal_load_status
				return this.tmp_user_sig_st;
			case 54:// active_user_load_status
				return this.tmp_active_u_st;
			
			case 55:// getPoints_load_status
				return this.tmp_getpoints_st;
			case 56:// getPoints_activePoint
				if( this.tmp_getpoints != null )return this.tmp_getpoints["activePoint"];
				return 0;
			case 57:// getPoints_totalPoint
				if( this.tmp_getpoints != null )return this.tmp_getpoints["totalPoint"];
				return 0;
			case 58:// getHistories_load_status
				return this.tmp_histories_st;
			case 59:// getHistories_remainingCount
				if( this.tmp_histories != null )return this.tmp_histories["remainingCount"];
				return 0;
			case 60:// getHistories_serverTime
				if( this.tmp_histories != null )return this.tmp_histories["serverTime"];
				return 0;
			case 61:// getHistories_LoadCount
				if( this.tmp_histories != null )return this.tmp_histories["histories"].length;
				return 0;
			case 62:// getHistories_advertiserName
				if( this.tmp_histories != null )return this.tmp_histories[this.ho.getExpParam()]["advertiserName"];
				return "";
			case 63:// getHistories_nicoadId
				if( this.tmp_histories != null )return this.tmp_histories[this.ho.getExpParam()]["nicoadId"];
				return 0;
			case 64:// getHistories_adPoint
				if( this.tmp_histories != null )return this.tmp_histories[this.ho.getExpParam()]["adPoint"];
				return 0;
			case 65:// getHistories_contribution
				if( this.tmp_histories != null )return this.tmp_histories[this.ho.getExpParam()]["contribution"];
				return 0;
			case 66:// getHistories_startedAt
				if( this.tmp_histories != null )return this.tmp_histories[this.ho.getExpParam()]["startedAt"];
				return 0;
			case 67:// getHistories_endedAt
				if( this.tmp_histories != null )return this.tmp_histories[this.ho.getExpParam()]["endedAt"];
				return 0;
			case 68:// getRanking_load_status
				return this.tmp_tmp_ranking_st;
			case 69:// getRanking_LoadCount
				if( this.tmp_ranking != null )return this.tmp_ranking.length;
				return 0;
			case 70:// getRanking_advertiserName
				if( this.tmp_ranking != null )return this.tmp_ranking[this.ho.getExpParam()]["advertiserName"];
				return "";
			case 71:// getRanking_totalContribution
				if( this.tmp_ranking != null )return this.tmp_ranking[this.ho.getExpParam()]["totalContribution"];
				return 0;
			case 72:// getRanking_rank
				if( this.tmp_ranking != null )return this.tmp_ranking[this.ho.getExpParam()]["rank"];
				return 0;
		}
		return 0;
	}
});
